#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "dpu2sampler4xi.py">
#<abstract4xi abstract = "DPU 2D sampler management"/>
#<refer4xi reference = "sampler4xi.py"/>
#<verify4xi verification = "10" target = "dpu2sampler4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'DPU2Sampler4Xi',                      # ACK 5.51  p106 
            
            'create2sampler4dpu',                  # ACK 5.51  p106  

            'get2samplerinfo4dpu',                 # ACK 5.51  p108
 
            'release2sampler4dpu',                 # ACK 5.51  p107                                         
            'retain2sampler4dpu',                  # ACK 5.51  p107
 
            'set2sampler4dpu',                     # ACK
            'set2samplercallback4dpu',             # ACK 
                              
            'trace2sampler4dpu'                    # ACK 
          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from dpu2buffer4xi import get2bufferinfo4dpu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from dpu2commandqueue4xi import DPU2CommandQueue4Xi
from dpu2commandqueue4xi import create2commandqueue4dpu 
from dpu2commandqueue4xi import flush2commandqueue4dpu
from dpu2commandqueue4xi import finish2commandqueue4dpu
from dpu2commandqueue4xi import get2commandqueueinfo4dpu
from dpu2commandqueue4xi import release2commandqueue4dpu
from dpu2commandqueue4xi import retain2commandqueue4dpu
from dpu2commandqueue4xi import set2commandqueue4dpu
from dpu2commandqueue4xi import trace2commandqueue4dpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from dpu2context4xi import DPU2Context4Xi 
from dpu2context4xi import create2context4dpu
from dpu2context4xi import get2context4dpu
from dpu2context4xi import release2context4dpu
from dpu2context4xi import retain2context4dpu
from dpu2context4xi import set2context4dpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from dpu2device4xi import DPU4Xi
from dpu2device4xi import init2dpu4xi 
from dpu2device4xi import set2dpu4xi
from dpu2device4xi import get2dpu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from dpu2event4xi import DPU2Event4Xi
from dpu2event4xi import create2event4dpu
from dpu2event4xi import get2eventinfo4dpu
from dpu2event4xi import release2event4dpu
from dpu2event4xi import retain2event4dpu
from dpu2event4xi import set2eventcallback4dpu 
from dpu2event4xi import set2event4dpu
from dpu2event4xi import trace2event4dpu
from dpu2event4xi import wait2event4dpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global dpu2sampler4xi                                                   # Sampler FOR DPU

global dpu2trace4xi                                                     # TRACE

           
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2sampler4dpu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF DPU2SAMPLER4XI5TEST - TRYING TO TRACE DPU: ', time4xi())      
#   print('=' *33)      
#   trace2dpu = None
#   try:
#       trace2dpu = trace2sampler4dpu() 
#       print('(Step 15B/25) OF DPU2SAMPLER4XI5TEST - TRACE2DPU: ', trace2dpu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'} 
#        except:
#       print('(Step 15Z1/25) OF DPU2SAMPLER4XI5TEST *** FAILED TO TRACE DPU: ', trace2dpu) 
#      
#">
# -------------------------------------------------------------------------------------------------   
def trace2sampler4dpu(task4trace2dpu=None):  

    '''
    creates callback to dpu2sampler4xi
    '''
    
    global dpu2trace4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2sampler4dpu" 
    method2print = "trace2sampler4dpu"

    message2print = "{(Step 1A/33) started" + "; trace2sampler4dpu-started: " + str(trace2sampler4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # <function trace2sampler4dpu at 0x00000000038CF5C8> 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2dpu-to-trace2sampler4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # None

    code2ack  = ' '
    code2nack = ' '    
    
    dpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2dpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY DPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2dpu = {}                                                                                            
            
        task4trace2dpu['CLASS']   = "trace2sampler4dpu"                                                               # DPUIZE ZPU TRACE!
        task4trace2dpu['METHOD']  = "trace2sampler4dpu" 
        task4trace2dpu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2sampler4dpu-failed " + str(dpu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2dpu-set-by-trace2sampler4dpu to: " + str(task4trace2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}; time: 22:37:25 11/07/11 Pacific Standard Time}

        
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY DPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2dpu-try-by-trace2sampler4dpu: " + str(task4trace2dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}; time: 22:37:25 11/07/11 Pacific Standard Time}
    

    try:
        dpu2trace4xi ['CLASS']  = task4trace2dpu['CLASS']                                                      # DPUIZE DPU TRACE!
        dpu2trace4xi ['METHOD']  = task4trace2dpu['METHOD']
        dpu2trace4xi ['MESSAGE'] = task4trace2dpu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; dpu2trace4xi-set-by-trace2sampler4dpu to: " + str(dpu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}; time: 22:37:25 11/07/11 Pacific Standard Time}

        

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; dpu-trace-failed-by-trace2sampler4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE DPU TRACE
        # =================================
        class2print   = task4trace2dpu['CLASS']                                                                # DPUIZE DPU TRACE!
        method2print  = task4trace2dpu['METHOD']
        
        message2print = task4trace2dpu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                     # DPUIZED TRACE FOR OPENCL CALLBACK!
        # { trace2sampler4dpu : trace2sampler4dpu ; (Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time} 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2sampler4dpu"                                                                        # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2sampler4dpu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-dpu-trace-failed-by-trace2sampler4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2sampler4dpu"                                                                        # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2sampler4dpu"                
        message2print = "{(Step 3D/33) performed" + "; dpu-trace-performed-by-trace2sampler4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}; time: 22:37:25 11/07/11 Pacific Standard Time}
 
        

        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; dpu-trace-failed-by-trace2sampler4dpu: " + str(task4trace2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; dpu2trace4xi-returning-by-trace2sampler4dpu: " + str(dpu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 
    #  'CLASS': 'trace2sampler4dpu', 
    #  'METHOD': 'trace2sampler4dpu'}; time: 22:37:25 11/07/11 Pacific Standard Time}

    return dpu2trace4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2samplercallback4dpu" usage = "
#
#   print('(Step 14A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK OF DPU ', time4xi())  
#   try:                               
#       response4setcallback2sampler = set2samplercallback4dpu()                                                                                                 
#       print('(Step 14B/700) OF DPU2SAMPLER4XI5TEST - SET SAMPLER CALLBACK OF DPU TO: ', response4setcallback2sampler)   
#       # <function trace2sampler4dpu at 0x00000000039676C8>
#   except:
#       print('(Step 14Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK OF DPU ', time4xi())  
# 
#">
# ------------------------------------------------------------------------------------------------- 
 
def set2samplercallback4dpu(task4set2samplercallback=None):

    '''
    registers callback function to dpu2sampler4xi
    '''
    global dpu2sampler4xi
    
    class2print = "set2samplercallback4dpu" 
    method2print = "set2samplercallback4dpu"
    
    message2print = "{(Step 1A/70) started" + "; set2samplercallback4dpu-started: " + str(set2samplercallback4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function set2samplercallback4dpu at 0x00000000038CF648> 
    
    try:
    
        dpu2sampler4xi ['CALLBACK'] = trace2sampler4dpu
        
        
        message2print = "{(Step 1C/70) returning" + "; callback-of-dpu2sampler4xi-returning-by-set2samplercallback4dpu: " + str(dpu2sampler4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # <function trace2sampler4dpu at 0x00000000038CF5C8>
        
        return dpu2sampler4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 1Z1/70) failed" + "; callback2sampler-failed-by-set2samplercallback4dpu: " + str(callback2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 1Z2/70) returning" + "; trace2sampler4dpu-returning-by-set2samplercallback4dpu: " + str(trace2sampler4dpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2sampler4dpu
            
#</function4xi> 




# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2sampler4dpu" usage = "
#   #1     
#   print('(Step 2A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER4DPU ', time4xi())      
#   try:
#       response4create2sampler = create2sampler4dpu()                                                                  
#       keys2response = response4create2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2sampler[key2response])
#           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
#           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
#           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ...
#           # CODE2ERROR  :  0
#           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK':  ...
#           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
#           # COUNT2REFERENCE  :  1
#           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 04:27:49 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'}
#           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
#           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # FUNCTION2CALLBACK  :  <function trace2sampler4dpu at 0x00000000039A76C8>
#           # NACK2RETURN  :   
#           # NORMALIZATION  :  CL_TRUE
#           # PIPE  :  (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
#           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
#           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B3D0B8>
#   except:
#       print('(Step 2Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4DPU *** ', time4xi())
#
#   #2 
#   print('(Step 123A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER for DPU ', time4xi()) 
#   # 
#   try:
#       xi2dpu = DPU2Sampler4Xi()                            
#       response4create2sampler = xi2dpu.create2sampler()                                  
#       keys2response = response4create2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4create2sampler[key2response])
#           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
#           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
#           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
#           # CODE2ERROR  :  0
#           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
#           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
#           # COUNT2REFERENCE  :  1
#           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'}
#           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
#           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # FUNCTION2CALLBACK  :  <function trace2sampler4dpu at 0x00000000039676C8>
#           # NACK2RETURN  :   
#           # NORMALIZATION  :  CL_TRUE
#           # PIPE  :  (<read-write PipeConnection, handle 408>, <read-write PipeConnection, handle 424>)
#           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
#           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02E48>
#           
#   except:
#       print('(Step 123Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER for DPU ', time4xi()) 
#          
#">
# -------------------------------------------------------------------------------------------------   
def create2sampler4dpu(task4sampler2dpu=None):

    '''
    creates 2D sampler for DPU
    '''
    
    global dpu2sampler4xi                                                                                              # 2D iamge of DPU  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2sampler4dpu" 
    method2print = "create2sampler4dpu"

    message2print = "{(Step 1A/70) started" + "; create2sampler4dpu-started: " + str(create2sampler4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2sampler4dpu at 0x00000000038EF6C8>
  
             
    message2print = "{(Step 1B/70) passed" + "; task4sampler2dpu-to-create2sampler4dpu: " + str(task4sampler2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None

    code2ack  = ' '
    code2nack = ' '    
    
    dpu2sampler4xi = {}                                                                                             # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4sampler2dpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO DPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4sampler2dpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4sampler2dpu-created-by-create2sampler4dpu to: " + str(task4sampler2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4dpu = trace2sampler4dpu                                                               # CALLBACK FUNCTION FOR DPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4dpu-created-by-create2sampler4dpu to: " + str(function2callback4dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2sampler4dpu at 0x00000000038EF5C8>
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2sampler4dpu"                                                         # MODULE OF DPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2sampler4dpu"                                                         # FUNCTION OF DPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2sampler4dpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR DPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2sampler4dpu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 21:58:10 11/07/11 Pacific Standard Time}', 
            #  'CLASS': 'create2sampler4dpu', 
            #  'METHOD': 'create2sampler4dpu'}; time: 21:58:10 11/07/11 Pacific Standard Time} 

            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4sampler2dpu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO DPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4sampler2dpu['FUNCTION2CALLBACK'] = function2callback4dpu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4sampler2dpu-created-by-create2sampler4dpu to: " + str(task4sampler2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2sampler4dpu at 0x00000000038EF5C8>, 
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 21:58:10 11/07/11 Pacific Standard Time}', 
            #  'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'}}; time: 21:58:10 11/07/11 Pacific Standard Time}

            
            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2sampler4dpu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2sampler4dpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 21:58:10 11/07/11 Pacific Standard Time} 
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2sampler4dpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4sampler2dpu['PLATFORM'] = platform2xi                                                          # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            context2dpu = {}
            message2print = "{(Step 3A/70) trying" + "; context2dpu-trying-by-create2sampler4dpu: " + str(context2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2dpu = get2context4dpu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2dpu-got-by-create2sampler4dpu: " + str(context2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ... 
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2dpu-failed-by-create2sampler4dpu: " + str(context2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4sampler2dpu ['CONTEXT'] = context2dpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - EXTRA                            
            # ---------------------------------------------------------------------------------------------    
            device2dpu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2dpu-trying-by-create2sampler4dpu: " + str(device2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2dpu = get2dpu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2dpu-got-by-create2sampler4dpu: " + str(device2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ....
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2dpu-failed-by-create2sampler4dpu: " + str(device2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4sampler2dpu ['DEVICE'] = device2dpu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4sampler2dpu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2dpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2dpu-trying-by-create2sampler4dpu: " + str(queue2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2dpu = Queue4Xi()                                                                                  # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2dpu-got-by-create2sampler4dpu: " + str(queue2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003B7E7F0>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2dpu-failed-by-create2sampler4dpu: " + str(queue2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4sampler2dpu ['QUEUE'] = queue2dpu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2dpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2dpu-trying-by-create2sampler4dpu: " + str(pipe2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2dpu = Pipe4Xi()                                                                                    # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2dpu-got-by-create2sampler4dpu: " + str(pipe2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2dpu-failed-by-create2sampler4dpu: " + str(pipe2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4sampler2dpu ['PIPE'] = pipe2dpu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2dpu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2dpu-trying-by-create2sampler4dpu: " + str(commandqueueinfo2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2dpu = get2commandqueueinfo4dpu()                                                    # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2dpu-got-by-create2sampler4dpu: " + str(commandqueueinfo2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # 'DATA2CALLBACK': {'MESSAGE': ... 
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2dpu-failed-by-create2sampler4dpu: " + str(commandqueueinfo2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4sampler2dpu ['COMMANDQUEUE'] = commandqueueinfo2dpu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2dpu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2dpu-trying-by-create2sampler4dpu: " + str(bufferinfo2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2dpu = get2bufferinfo4dpu()                                                                   # SYSTEM CREATES BUFFER FOR DPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2dpu-got-by-create2sampler4dpu: " + str(bufferinfo2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2dpu-failed-by-create2sampler4dpu: " + str(bufferinfo2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4sampler2dpu ['BUFFER'] = bufferinfo2dpu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2dpu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2dpu-trying-by-create2sampler4dpu: " + str(eventinfo2dpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2dpu = get2eventinfo4dpu()                                                                     # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2dpu-got-by-create2sampler4dpu: " + str(eventinfo2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2dpu-failed-by-create2sampler4dpu: " + str(eventinfo2dpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4sampler2dpu ['EVENT'] = eventinfo2dpu             
            
            # ---------------------------------------------------------------------------------------------
            # (11) NORMALIZATION - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            normalization2dpu  = 'CL_TRUE'                      # CL_TRUE or CL_FALSE
           
            message2print = "{(Step 11B/70) set" + "; normalization2dpu-set-by-create2sampler4dpu to: " + str(normalization2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # CL_TRUE 
            code2ack  = code2ack + '11B-' 
        
            task4sampler2dpu ['NORMALIZATION'] = normalization2dpu 
            
                        
            # ---------------------------------------------------------------------------------------------
            # (12) ADDRESSINGMODE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            addressingmode2dpu  = 'CL_ADDRESS_MIRRORED_REPEAT'  # CL_ADDRESS_MIRRORED_REPEAT, CL_ADDRESS_REPEAT, CL_ADDRESS_CLAMP_TO_EDGE, CL_ADDRESS_CLAMP, CL_ADDRESS_NONE
           
            message2print = "{(Step 12B/70) set" + "; addressingmode2dpu-set-by-create2sampler4dpu to: " + str(addressingmode2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # CL_ADDRESS_MIRRORED_REPEAT 
            code2ack  = code2ack + '12B-' 
        
            task4sampler2dpu ['ADDRESSINGMODE'] = addressingmode2dpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14) FILTERINGMODE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            filteringmode2dpu  = 'CL_FILTER_NEAREST'  # CL_FILTER_NEAREST, or CL_FILTER_LINEAR
           
            message2print = "{(Step 14B/70) set" + "; filteringmode2dpu-set-by-create2sampler4dpu to: " + str(filteringmode2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # CL_FILTER_NEAREST
            code2ack  = code2ack + '14B-' 
        
            task4sampler2dpu ['FILTERINGMODE'] = filteringmode2dpu
            
            # ---------------------------------------------------------------------------------------------
            # (15) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2dpu  = 1
           
            message2print = "{(Step 15B/70) set" + "; count2reference2dpu-set-by-create2sampler4dpu to: " + str(count2reference2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '15B-' 
        
            task4sampler2dpu ['COUNT2REFERENCE'] = count2reference2dpu                                    
                                                                                                                      
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4sampler2dpu-yielded-by-create2sampler4dpu: " + str(task4sampler2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4sampler2dpu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2sampler4dpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # ['ADDRESSINGMODE', 'BUFFER', 'CODE2ERROR', 'COMMANDQUEUE', 'CONTEXT', 'COUNT2REFERENCE', 'DATA2CALLBACK', 'DEVICE', 'EVENT', 'FILTERINGMODE', 'FUNCTION2CALLBACK', 'NORMALIZATION', 'PIPE', 'PLATFORM', 'QUEUE']; time: 21:58:10 11/07/11 Pacific Standard Time}

    
  
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE SAMPLER FOR DPU! 
    # ---------------------------------------------------------------------------------------------    
    dpu2sampler4xi = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; dpu2sampler4xi-initialized-by-create2sampler4dpu to: " + str(dpu2sampler4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {} 
    
    message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA 
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['DATA2CALLBACK'] = task4sampler2dpu['DATA2CALLBACK']
        
        message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 21:58:10 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'} 
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['FUNCTION2CALLBACK'] = task4sampler2dpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # <function trace2sampler4dpu at 0x00000000038EF5C8> 
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['PLATFORM'] = task4sampler2dpu['PLATFORM']
        
        message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1} 
  
        code2ack  = code2ack + '22C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2dpu-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['CONTEXT'] = task4sampler2dpu['CONTEXT']
        
        message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ... 
        
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['DEVICE'] = task4sampler2dpu['DEVICE']
        
        message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ... 
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['CODE2ERROR'] = task4sampler2dpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['QUEUE'] = task4sampler2dpu['QUEUE']
        
        message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <queue4xi.Queue4Xi object at 0x0000000003B7E7F0> 
        
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['PIPE'] = task4sampler2dpu['PIPE']
        
        message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>) 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-dpu2sampler4xi-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['COMMANDQUEUE']  = task4sampler2dpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ... 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
              
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['BUFFER']  = task4sampler2dpu['BUFFER']  
 
        message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['EVENT']  = task4sampler2dpu['EVENT']  
 
        message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
        
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'            
                

    message2print = "{(Step 31A/70) try" + "; normalization-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31) NORMALIZATION - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['NORMALIZATION']  = task4sampler2dpu['NORMALIZATION']  
 
        message2print = "{(Step 31B/70) initialized" + "; normalization-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['NORMALIZATION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_TRUE; 
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; normalization-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '31Z1-'     

    message2print = "{(Step 32A/70) try" + "; addressingmode-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) ADDRESSINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['ADDRESSINGMODE']  = task4sampler2dpu['ADDRESSINGMODE']  
 
        message2print = "{(Step 32B/70) initialized" + "; addressingmode-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['ADDRESSINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_ADDRESS_MIRRORED_REPEAT
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; addressingmode-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '32Z1-'     
        
    message2print = "{(Step 33A/70) try" + "; filteringmode-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) FILTERINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['FILTERINGMODE']  = task4sampler2dpu['FILTERINGMODE']  
 
        message2print = "{(Step 33B/70) initialized" + "; filteringmode-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['FILTERINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_FILTER_NEAREST 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; filteringmode-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z1-'     
        
    message2print = "{(Step 34A/70) try" + "; count2reference-try-by-create2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['COUNT2REFERENCE']  = task4sampler2dpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 34B/70) initialized" + "; count2reference-created-by-create2sampler4dpu to: " + str(dpu2sampler4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; count2reference-yielded-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '34Z1-'     
        
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2sampler4xi ['ACK2RETURN']  = code2ack
    dpu2sampler4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; dpu2sampler4xi-returning-by-create2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
    
    return dpu2sampler4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2sampler4dpu" usage = "
#    
#   print('(Step 4B/33) OF DPU2SAMPLER4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
#   platform2xi = {}
#   try:
#       platform2xi = get2platformids4xi()
#       print('(Step 4B/33) of CONTEXT4DPU5TEST - GOT PLATFORMIDS4XI', platform2xi) 
#   except:
#       print('(Step 4Z/33) of CONTEXT4DPU5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
#    
# 
#   ... other data for set ...
#    
#        
#   response4set2sampler = {} 
#   print('(Step 11F/700) OF DPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER4DPU ', time4xi())   
#   try:                               
#       response4set2sampler = set2sampler4dpu(task4set2sampler)                                                                                                         
#       keys2response = response4set2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4set2sampler[key2response])
#           # ACK2RETURN  :   23B-24B-25B-26B-27B-28B-31B-32B-33B-
#           # ADDRESSINGMODE  :  CL_ADDRESS_REPEAT
#           # BUFFER  :  {'CODE2ERROR': 0 ...
#           # CODE2ERROR  :  0
#           # COMMANDQUEUE  :  {'CODE2ERROR': 0, ...
#           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
#           # COUNT2REFERENCE  :  1
#           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'}
#           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
#           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': ...
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # FUNCTION2CALLBACK  :  <function trace2sampler4dpu at 0x00000000038CF5C8>
#           # NACK2RETURN  :   21Z1-22Z2-22Z3-29Z1-30Z1-34Z1-
#           # NORMALIZATION  :  CL_TRUE
#           # PIPE  :  (<read-write PipeConnection, handle 520>, <read-write PipeConnection, handle 524>)
#           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
#           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B53B00>
#           
#           
#   except:
#       print('(Step 11Z2/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER4DPU *** ', time4xi())  
#
#">
# -------------------------------------------------------------------------------------------------   
def set2sampler4dpu(task4samplerset2dpu=None):

    '''
    sets 2D samplers for DPU
    '''
    global dpu2sampler4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2sampler4dpu"
    method2print = "set2sampler4dpu"

    message2print = "{(Step 1A/33) started" + "; set2sampler4dpu-started: " + str(set2sampler4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2sampler4dpu at 0x00000000038EF748>
    
    message2print = "{(Step 1B/33) passed" + "; task4samplerset2dpu-to-set2sampler4dpu: " + str(task4samplerset2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0, 
    #  'QUEUE': <queue4xi.Queue4Xi object at 0x0000000003918390>, 
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK':...
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if dpu2sampler4xi is None:
            dpu2sampler4xi = create2sampler4dpu()                                                                              # INITIALIZE SAMPLER FOR DPU 
            message2print = "{(Step 1C/70) set" + "; dpu2sampler4xi-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2sampler4dpu-skipped-by-set2sampler4dpu: " + str(create2sampler4dpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function create2sampler4dpu at 0x00000000038EF6C8>                                 
    except:
        try:
            dpu2sampler4xi = create2sampler4dpu()
            message2print = "{(Step 1E/70) set" + "; dpu2sampler4xi-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            dpu2sampler4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET            
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['DATA2CALLBACK'] = task4samplerset2dpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['FUNCTION2CALLBACK'] = task4samplerset2dpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['PLATFORM'] = task4samplerset2dpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2dpu-try-by-set2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['CONTEXT'] = task4samplerset2dpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['DEVICE'] = task4samplerset2dpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'RESOLUTION2TIMER4PROFILING': 318 ... 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['CODE2ERROR'] = task4samplerset2dpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['QUEUE'] = task4samplerset2dpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <queue4xi.Queue4Xi object at 0x0000000003918390>
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['PIPE'] = task4samplerset2dpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # (<read-write PipeConnection, handle 520>, <read-write PipeConnection, handle 524>) 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-dpu2sampler4xi-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['COMMANDQUEUE']  = task4samplerset2dpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['BUFFER']  = task4samplerset2dpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2sampler4dpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['EVENT']  = task4samplerset2dpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; normalization-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31) NORMALIZATION - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['NORMALIZATION']  = task4samplerset2dpu['NORMALIZATION']  
 
        message2print = "{(Step 31B/70) set" + "; normalization-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['NORMALIZATION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_TRUE
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; normalization-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
        
    message2print = "{(Step 32A/70) try" + "; addressingmode-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) ADDRESSINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['ADDRESSINGMODE']  = task4samplerset2dpu['ADDRESSINGMODE']  
 
        message2print = "{(Step 32B/70) set" + "; addressingmode-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['ADDRESSINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_ADDRESS_CLAMP_TO_EDGE
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; addressingmode-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; filteringmode-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) FILTERINGMODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['FILTERINGMODE']  = task4samplerset2dpu['FILTERINGMODE']  
 
        message2print = "{(Step 33B/70) set" + "; filteringmode-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['FILTERINGMODE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # CL_FILTER_LINEAR
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; filteringmode-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; count2reference-try-by-set2sampler4dpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        dpu2sampler4xi['COUNT2REFERENCE']  = task4samplerset2dpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 34B/70) set" + "; count2reference-set-by-set2sampler4dpu to: " + str(dpu2sampler4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; count2reference-yielded-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        
        code2nack  = code2nack + '34Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2sampler4xi ['ACK2RETURN']  = code2ack
    dpu2sampler4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; dpu2sampler4xi-returning-by-set2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return dpu2sampler4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2sampler4dpu" usage = "
#
#   task4release2sampler  = {} 
#   task4release2sampler  ['COUNT2REFERENCE'] = 1 
#   response4release2sampler = {}
#   
#   print('(Step 12A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF DPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4release2sampler = release2sampler4dpu(task4release2sampler)                                                                                             
#                        
#       keys2response = response4release2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4release2sampler[key2response])
#           # COUNT2REFERENCE  :  0
#       
#   except:
#       print('(Step 12Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF DPU DEVICE ', time4xi()) 
#                 
#">
# -------------------------------------------------------------------------------------------------   
def release2sampler4dpu(task4release2dpu=None):

    '''
    releases dpu2sampler4xi
    '''
    global dpu2sampler4xi  
    global code2ack
    global code2nack
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2sampler4dpu"
    method2print = "release2sampler4dpu" 

    message2print = "{(Step 1A/33) started" + "; release2sampler4dpu-started: " + str(release2sampler4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function release2sampler4dpu at 0x00000000038CF7C8> 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2dpu-to-release2sampler4dpu: " + str(task4release2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}
    

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if dpu2sampler4xi is None:
            dpu2sampler4xi = create2sampler4dpu()                                                                       # INITIALIZE SAMPLER                 
    except:
        try:
            dpu2sampler4xi = create2sampler4dpu()
        except:
            dpu2sampler4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; dpu2sampler4xi-yielded-by-release2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2sampler4dpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2dpu is None:
        task4release2dpu = {}
        task4release2dpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        dpu2sampler4xi['COUNT2REFERENCE'] = dpu2sampler4xi['COUNT2REFERENCE'] - task4release2dpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2sampler4dpu: " + str(dpu2sampler4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if dpu2sampler4xi['COUNT2REFERENCE'] < 0:
            dpu2sampler4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2sampler4dpu: " + " ** " + str(dpu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            dpu2sampler4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2sampler4dpu: " + " ** " + str(dpu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; dpu2sampler4xi-yielded-by-release2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    dpu2sampler4xi ['ACK2RETURN']  = code2ack
    dpu2sampler4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; dpu2sampler4xi-returning-by-release2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 'COUNT2REFERENCE': 0
    
    
    return dpu2sampler4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2sampler4dpu" usage = "
#
#   task4retain2sampler  = {}
#   task4retain2sampler  ['COUNT2REFERENCE'] = 1 
#   response4retain2sampler = {}
#   print('(Step 13A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF DPU DEVICE ', time4xi())   
#   try:                               
#       response4retain2sampler = retain2sampler4dpu(task4retain2sampler)                                                                                                 
#                      
#       keys2response = response4retain2sampler.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4retain2sampler[key2response])
#           # COUNT2REFERENCE  :  1
#           
#   except:
#       print('(Step 13Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF DPU DEVICE ', time4xi())  
#
#">
# -------------------------------------------------------------------------------------------------   
def retain2sampler4dpu(task4retain2dpu=None):

    '''
    retains either dpu2sampler4xi
    '''
    global dpu2sampler4xi 
    
     
    global code2ack
    global code2nack
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2sampler4dpu"
    method2print = "retain2sampler4dpu"

    message2print = "{(Step 1A/33) started" + "; retain2sampler4dpu-started: " + str(retain2sampler4dpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function retain2sampler4dpu at 0x00000000038CF848> 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2dpu-to-retain2sampler4dpu: " + str(task4retain2dpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2dpu is None:
        task4retain2dpu = {}
        task4retain2dpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2dpu-set-by-retain2sampler4dpu to: " + str(task4retain2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2dpu.keys():
        pass
    else:
        task4retain2dpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2sampler4dpu to: " + str(task4retain2dpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2dpu['COUNT2REFERENCE'] < 1:
        task4retain2dpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2sampler4dpu to: " + str(task4retain2dpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE SAMPLER IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if dpu2sampler4xi is None:
            dpu2sampler4xi = create2sampler4dpu()
            message2print = "{(Step 4A/70) created" + "; dpu2sampler4xi-created-by-retain2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            dpu2sampler4xi = create2sampler4dpu()
            message2print = "{(Step 4B/70) created" + "; dpu2sampler4xi-created-by-retain2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            dpu2sampler4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; dpu2sampler4xi-yielded-by-retain2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        dpu2sampler4xi['COUNT2REFERENCE'] = dpu2sampler4xi['COUNT2REFERENCE'] + task4retain2dpu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2sampler4dpu: " + str(dpu2sampler4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1              
        if dpu2sampler4xi['COUNT2REFERENCE'] <= 0:
            dpu2sampler4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2sampler4dpu: " + " ** " + str(dpu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            dpu2sampler4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2sampler4dpu: " + " ** " + str(dpu2sampler4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; dpu2sampler4xi-yielded-by-retain2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    dpu2sampler4xi ['ACK2RETURN']  = code2ack
    dpu2sampler4xi ['NACK2RETURN'] = code2nack     
    message2print = "{(Step 70A/70) returning" + "; dpu2sampler4xi-returning-by-retain2sampler4dpu: " + str(dpu2sampler4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 'COUNT2REFERENCE': 1
    
    
    return dpu2sampler4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2samplerinfo4dpu" usage = "
#
#   print('=' *33)          
#   print('(Step 3B1/700) OF DPU2SAMPLER4XI5TEST - TRYING TO GET SOME SAMPLER INFO FOR DPU ', time4xi())     
#   print('=' *33)    
#   task4getinfo2sampler = {}
#   task4getinfo2sampler ['NORMALIZATION'] = 0
#   task4getinfo2sampler ['ADDRESSINGMODE'] = 0
#   task4getinfo2sampler ['FILTERINGMODE'] = 0  
#   try:
#       response4samplerinfo2dpu = get2samplerinfo4dpu(task4getinfo2sampler)                                                                      
#       print('(Step 3B2/700) OF DPU2SAMPLER4XI5TEST - GOT SOME SAMPLER INFO FOR DPU ', time4xi())  
#       keys2response = response4samplerinfo2dpu.keys()
#       for key2response in sorted(keys2response):
#           print(key2response, ' : ', response4samplerinfo2dpu[key2response])
#           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
#           # FILTERINGMODE  :  CL_FILTER_NEAREST
#           # NORMALIZATION  :  CL_TRUE 
#           
#   except:
#       print('(Step 3Z2/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO GET SOME SAMPLER INFO FOR DPU', time4xi())
#            
#">
# -------------------------------------------------------------------------------------------------   
def get2samplerinfo4dpu(task4getinfo2sampler=None):

    '''
    gets dpu2sampler4xi
    '''
    
    global dpu2sampler4xi
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2samplerinfo4dpu"
    method2print = "get2samplerinfo4dpu"

    message2print = "{(Step 0A/33) started" + "; get2samplerinfo4dpu-started: " + str(get2samplerinfo4dpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # <function get2samplerinfo4dpu at 0x00000000038EF8C8> 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2sampler-passed-to-get2samplerinfo4dpu: " + str(task4getinfo2sampler) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # {'FILTERINGMODE': 0, 'NORMALIZATION': 0, 'ADDRESSINGMODE': 0}
    
    
    sampler2dpu = {}
    try: 
        if dpu2sampler4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SAMPLER FOR DPU           
            # -------------------------------------------------------------------------------------           
            sampler2dpu = create2sampler4dpu()
            message2print = "{(Step 1B2/33) initialized" + "; sampler2dpu-initialized-by-get2samplerinfo4dpu to: " + str(sampler2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; dpu2sampler4xi-using-by-get2samplerinfo4dpu: " + str(dpu2sampler4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
            
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF THE SAMPLER INFO OF DPU          
        # -------------------------------------------------------------------------------------     
        dimension2xi = 0
        
        if task4getinfo2sampler is None:
            task4getinfo2sampler = {}
            sampler2dpu = dpu2sampler4xi
            message2print = "{(Step 1C/33) using" + "; sampler2dpu-got-by-get2samplerinfo4dpu: " + str(sampler2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4samplerinfo = task4getinfo2sampler.keys()


        keys2task = task4getinfo2sampler.keys()
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2sampler4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # FILTERINGMODE
                 
                sampler2dpu [key2task] = dpu2sampler4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-sampler2dpu-set-by-get2samplerinfo4dpu to: " + str(sampler2dpu [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # CL_FILTER_NEAREST; NORMALIZATION; ADDRESSINGMODE
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2sampler4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2sampler-using-by-get2sampler4dpu: " + str(task4getinfo2sampler)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; dpu2sampler4xi-using-by-get2sampler4dpu: " + str(dpu2sampler4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                           
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            sampler2dpu = create2sampler4dpu()
            message2print = "{(Step 1F/33) initialized" + "; sampler2dpu-initialized-by-get2samplerinfo4dpu to: " + str(sampler2dpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2sampler is None:
                sampler2dpu = dpu2sampler4xi
                message2print = "{(Step 1G/33) got" + "; sampler2dpu-got-by-get2samplerinfo4dpu: " + str(sampler2dpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2sampler.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2sampler4dpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        sampler2dpu [key2task] = dpu2sampler4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-sampler2dpu-set-by-get2samplerinfo4dpu to: " + str(sampler2dpu [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2sampler4dpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                            
        except:
            sampler2dpu = {}
            message2print = "{(Step 1Z3/70) yielded" + "; sampler2dpu-yielded-by-get2sampler4dpu: " + str(sampler2dpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; sampler2dpu-returning-by-get2samplerinfo4dpu: " + str(sampler2dpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    # FILTERINGMODE  :  CL_FILTER_NEAREST
    # NORMALIZATION  :  CL_TRUE
    
    return sampler2dpu
            
#</function4xi> 
 

                                               
# =================================================================================================
#<class4xi class = "DPU2Sampler4Xi" base = "object" child = "None"
#    synopsis = "offers  methods for DPU samplers" usage = "Sampler4Xi of DPU"
#>
# =================================================================================================
class DPU2Sampler4Xi(object): 
    ''' 
    DPU2Sampler4Xi offers  methods for DPU samplers
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2dpu = cpu_corecount4xi()
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (

            'create2sampler',                  # ACK 5.51  p106  

            'get2samplerinfo',                 # ACK 5.51  p108
 
            'release2sampler',                 # ACK 5.51  p107                                         
            'retain2sampler',                  # ACK 5.51  p107
 
            'set2sampler',                     # ACK
            'set2samplercallback',             # ACK 
                              
            'trace2sampler4dpu'                # ACK                 
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-DPU2Sampler4Xi" usage = "
    # 
    #   print('=' *33)          
    #   print('(Step 105A/700) OF DPU2SAMPLER4XI5TEST - CREATING SAMPLER4DPU OBJECT ', time4xi())     
    #   print('=' *33)  
    # 
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                        
    #       # ---------------------------------------------------------------------------------------------        
    #       samplerobject2dpu = DPU2Sampler4Xi()
    #       print('(Step 105B/700) OF DPU2SAMPLER4XI5TEST - CREATED SAMPLER4DPU OBJECT: ', samplerobject2dpu)                                  
    #       # <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B02320>
    #       
    #   except:
    #       print('(Step 105Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4DPU OBJECT')    
    # 
    #">
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4sampler2dpu = None):
        '''
        _init__ method initializes DPU2Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "DPU2Sampler4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-DPU2Sampler4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 22:37:25 11/07/11 Pacific Standard Time} 

        message2print = "{(Step 1B/33) borning" + "; dpu2sampler2xi-of-DPU2Sampler4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-dpu2sampler2xi-of-DPU2Sampler4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'> 
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2dpu-sharing-by-dpu2sampler2xi-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi.classvariable2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4           
                                
        message2print = "{(Step 1E/33) passed" + "; task4sampler2dpu-passed-to-init-of-DPU2Sampler4Xi: " + str(task4sampler2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                        
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4sampler2dpu-passing-to-create2sampler4dpu-by-init-of-DPU2Sampler4Xi: " + str(task4sampler2dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
        
        dpu2sampler2xi = create2sampler4dpu(task4sampler2dpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2sampler4dpu-performed-by-init-of-DPU2Sampler4Xi: " + str(create2sampler4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2sampler4dpu at 0x00000000038CF6C8>
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; dpu2sampler2xi-of-DPU2Sampler4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-dpu2sampler2xi-of-DPU2Sampler4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2dpu-shared-by-dpu2sampler2xi-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi.classvariable2dpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4          
       
        message2print = "{(Step 3D/33) returning" + "; init-of-DPU2Sampler4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 22:37:25 11/07/11 Pacific Standard Time
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2sampler-of-DPU2Sampler4Xi" usage = "
    # 
    #   print('(Step 123A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER for DPU ', time4xi()) 
    #   # 
    #   try:
    #       xi2dpu = DPU2Sampler4Xi()                            
    #       response4create2sampler = xi2dpu.create2sampler()                                  
    #       keys2response = response4create2sampler.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4create2sampler[key2response])
    #           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
    #           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    #           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
    #           # CODE2ERROR  :  0
    #           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
    #           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
    #           # COUNT2REFERENCE  :  1
    #           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'}
    #           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
    #           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': 
    #           # FILTERINGMODE  :  CL_FILTER_NEAREST
    #           # FUNCTION2CALLBACK  :  <function trace2sampler4dpu at 0x00000000039676C8>
    #           # NACK2RETURN  :   
    #           # NORMALIZATION  :  CL_TRUE
    #           # PIPE  :  (<read-write PipeConnection, handle 408>, <read-write PipeConnection, handle 424>)
    #           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    #           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02E48>
    #           
    #   except:
    #       print('(Step 123Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER for DPU ', time4xi())                   
    #                     
    #">   
    # ---------------------------------------------------------------------------------------------   
    def create2sampler(self, task4sampler2create = None):
        '''
        create2sampler method creates 2D sampler objects of DPU2Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "create2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; create2sampler-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4sampler2create-passed-to-create-of-DPU2Sampler4Xi: " + str(task4sampler2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4sampler2create-passing-to-create2sampler4dpu-by-create2sampler-of-DPU2Sampler4Xi: " + str(task4sampler2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        dpu2sampler2xi = create2sampler4dpu(task4sampler2create)

        message2print = "{(Step 2B/33) performed" + "; create2sampler4dpu-performed-by-create2sampler-of-DPU2Sampler4Xi: " + str(create2sampler4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; dpu2sampler2xi-returning-by-create2sampler-of-DPU2Sampler4Xi: " + str(dpu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return dpu2sampler2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2sampler-of-DPU2Sampler4Xi" usage = "
    #   print('(Step 1A/33) OF DPU2SAMPLER4XI - TRYING TO SET DPU SAMPLER')
    #   try:
    #       cc2xi = DPU2Sampler4Xi()                            
    #       sampler2dpu = cc2xi.set2sampler()                                  
    #       print('(Step 1B/33) OF DPU4XI5TEST - SET DPU SAMPLER: ', sampler2dpu)                                                  
    #   except:
    #       print('(Step 1Z/33) OF DPU4XI5TEST *** FAILED TO SET DPU SAMPLER ***')  
    #">
    # ---------------------------------------------------------------------------------------------   
    def set2sampler(self, task4set2sampler = None):
        '''
        sets 2D sampler DPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "set2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; set2sampler-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2sampler-passed-to-set2sampler-of-DPU2Sampler4Xi: " + str(task4set2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'CODE2ERROR': 0, 'ADDRESSINGMODE': 'CL_ADDRESS_CLAMP_TO_EDGE' ...
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2sampler-passing-to-set2sampler4dpu-by-set2sampler-of-DPU2Sampler4Xi: " + str(task4set2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # {'CODE2ERROR': 0, 'ADDRESSINGMODE': 'CL_ADDRESS_CLAMP_TO_EDGE'
        
        dpu2sampler2xi = set2sampler4dpu(task4set2sampler)

        message2print = "{(Step 2B/33) performed" + "; set2sampler4dpu-performed-by-set2sampler-of-DPU2Sampler4Xi: " + str(set2sampler4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function set2sampler4dpu at 0x00000000038CF748>
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2sampler2xi-returning-by-set2sampler-of-DPU2Sampler4Xi: " + str(dpu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, 'DATA2CALLBACK': ...
        
                
        return dpu2sampler2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2samplerinfo-of-DPU2Sampler4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF DPU2SAMPLER4XI5TEST - TRYING TO GET SAMPLER INFO ', time4xi())    
    #   try:                               
    #       response4get2samplerinfo = samplerobject2dpu.get2samplerinfo()                                 
    #                                
    #       keys2response = response4get2samplerinfo.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4get2samplerinfo[key2response])
    #           # ACK2RETURN  :   1D-1E-2C-2B-3B-4B-5B-6B-7B-8B-9B-10B-11B-12B-14B-15B-21A1-22B1-22C1-23B-24B-25B-26B-27B-28B-29B-30B-31B-32B-33B-34B-
    #           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    #           # BUFFER  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
    #           # CODE2ERROR  :  0
    #           # COMMANDQUEUE  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0
    #           # CONTEXT  :  {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': 
    #           # COUNT2REFERENCE  :  1
    #           # DATA2CALLBACK  :  {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4dpu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'create2sampler4dpu', 'METHOD': 'create2sampler4dpu'}
    #           # DEVICE  :  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568'
    #           # EVENT  :  {'CODE2ERROR': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2event4dpu-failed ; time: 04:32:25 11/07/11 Pacific Standard Time}', 
    #           # FILTERINGMODE  :  CL_FILTER_NEAREST
    #           # FUNCTION2CALLBACK  :  <function trace2sampler4dpu at 0x00000000039676C8>
    #           # NACK2RETURN  :   
    #           # NORMALIZATION  :  CL_TRUE
    #           # PIPE  :  (<read-write PipeConnection, handle 412>, <read-write PipeConnection, handle 416>)
    #           # PLATFORM  :  {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    #           # QUEUE  :  <queue4xi.Queue4Xi object at 0x0000000003B02F98>
    #           # (Step 106A2/700) OF DPU2SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF DPU DEVICE  04:32:25 11/07/11 Pacific Standard Time
    #           # ADDRESSINGMODE  :  CL_ADDRESS_MIRRORED_REPEAT
    #           # COUNT2REFERENCE  :  1
    #           # FILTERINGMODE  :  CL_FILTER_NEAREST
    #           # NORMALIZATION  :  CL_TRUE
    #           
    #   except:
    #       print('(Step 106Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO GET SAMPLER INFO ', time4xi()) 
    # 
    # ">
    # ---------------------------------------------------------------------------------------------   
    def get2samplerinfo(self, task4getinfo2sampler=None):
        '''
        get2samplerinfo method gets 2D objects of DPU2Sampler4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "get2samplerinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2samplerinfo-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        dpu2sampler2xi = get2samplerinfo4dpu(task4getinfo2sampler)
        
        message2print = "{(Step 2A/33) returning" + "; dpu2sampler2xi-returning-by-get2samplerinfo-of-DPU2Sampler4Xi: " + str(dpu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
        
        
        return dpu2sampler2xi
                            
    #</methodize4xi>


            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2sampler-of-DPU2Sampler4Xi" usage = "
    #
    # ---------------------------------------------------------------------------------------------
    # RELEASE SAMPLER BY DECREMENTING REFERENCE COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    #
    #   task4release2sampler  = {} 
    #   task4release2sampler  ['COUNT2REFERENCE'] = 1 
    #   response4release2sampler = {}
    #  
    #   print('(Step 133A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF DPU DEVICE ', time4xi())    
    #   # 
    #   try:                               
    #       response4release2sampler = xi2dpu.release2sampler(task4release2sampler)                                                                                             
    #                       
    #       keys2response = response4release2sampler.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4release2sampler[key2response])
    #           # COUNT2REFERENCE  :  0
    #   except:
    #       print('(Step 133Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF DPU DEVICE ', time4xi())  
    #  
    #">
    # ---------------------------------------------------------------------------------------------   
    def release2sampler(self, task4release2sampler = None):
        '''
        releases DPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "release2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; release2sampler-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
            
        message2print = "{(Step 1B/33) passed" + "; task4release2sampler-passed-to-release2sampler-of-DPU2Sampler4Xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'COUNT2REFERENCE': 1}
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2sampler-passing-to-release2sampler4dpu-by-release2sampler-of-DPU2Sampler4Xi: " + str(task4release2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # {'COUNT2REFERENCE': 1}
  
        dpu2sampler2xi = release2sampler4dpu(task4release2sampler)

        message2print = "{(Step 2B/33) performed" + "; release2sampler4dpu-performed-by-release2sampler-of-DPU2Sampler4Xi: " + str(release2sampler4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function release2sampler4dpu at 0x00000000038CF7C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2sampler2xi-returning-by-release2sampler-of-DPU2Sampler4Xi: " + str(dpu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...                          
                
        return dpu2sampler2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2sampler-of-DPU2Sampler4Xi" usage = "
    #
    # ---------------------------------------------------------------------------------------------
    # RETAIN SAMPLER BY DECREASING REFERENCE WITH 1             
    # ---------------------------------------------------------------------------------------------    
    # 
    #   task4retain2sampler  = {}
    #   task4retain2sampler  ['COUNT2REFERENCE'] = 1 
    #   response4retain2sampler = {}
    #   print('(Step 134A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF DPU DEVICE ', time4xi())   
    #   try:                               
    #       response4retain2sampler = xi2dpu.retain2sampler(task4retain2sampler)                                                                                                 
    #                      
    #       keys2response = response4retain2sampler.keys()
    #       for key2response in sorted(keys2response):
    #           print(key2response, ' : ', response4retain2sampler[key2response])
    #           # COUNT2REFERENCE  :  1
    #   except:
    #       print('(Step 134Z1/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF DPU DEVICE ', time4xi())
    # 
    #">
    # ---------------------------------------------------------------------------------------------   
    def retain2sampler(self, task4retain2sampler = None):
        '''
        retains DPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "retain2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; retain2sampler-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2sampler-of-DPU2Sampler4Xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # {'COUNT2REFERENCE': 1} 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2sampler4dpu-by-retain-of-DPU2Sampler4Xi: " + str(task4retain2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # {'COUNT2REFERENCE': 1}
        
  
        dpu2sampler2xi = retain2sampler4dpu(task4retain2sampler)

        message2print = "{(Step 2B/33) performed" + "; retain2sampler4dpu-performed-by-retain2sampler-of-DPU2Sampler4Xi: " + str(retain2sampler4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function retain2sampler4dpu at 0x00000000039DF948>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; dpu2sampler2xi-returning-by-retain2sampler-of-DPU2Sampler4Xi: " + str(dpu2sampler2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
            
                
        return dpu2sampler2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2sampler-of-DPU2Sampler4Xi" usage = "
    #   print('=' *33)          
    #   print('(Step 15A/25) OF DPU2SAMPLER4XI5TEST - TRYING TO TRACE DPU: ', time4xi())      
    #   print('=' *33)      
    #   trace2dpu = None
    #   try:
    #       trace2dpu = xi2dpu.trace2sampler () 
    #       print('(Step 15B/25) OF DPU2SAMPLER4XI5TEST - TRACE2DPU: ', trace2dpu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 01:39:15 10/06/11 Pacific Daylight Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}
    #   except:
    #       print('(Step 15Z1/25) OF DPU2SAMPLER4XI5TEST *** FAILED TO TRACE DPU: ', trace2dpu)     
    #">
    # ---------------------------------------------------------------------------------------------   
    def trace2sampler(self, task4trace2sampler = None):
        '''
        traces DPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "trace2sampler"
                     
        message2print = "{(Step 1A/33) started" + "; trace2sampler-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2sampler-passed-to-trace-of-DPU2Sampler4Xi: " + str(task4trace2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2sampler-passing-to-trace2sampler4dpu-by-trace2sampler-of-DPU2Sampler4Xi: " + str(task4trace2sampler) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None
         
  
        trace2xi = trace2sampler4dpu(task4trace2sampler)

        message2print = "{(Step 2B/33) performed" + "; trace2sampler4dpu-performed-by-trace2sampler-of-DPU2Sampler4Xi: " + str(trace2sampler4dpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function trace2sampler4dpu at 0x00000000038CF5C8>
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2sampler-of-DPU2Sampler4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 22:37:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}; time: 22:37:25 11/07/11 Pacific Standard Time}
 
        
                 
                
        return trace2xi
                                                           
    #</methodize4xi>       


    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2samplercallback-of-DPU2Sampler4Xi" usage = "
    #
    #   print('(Step 124A/700) OF DPU2SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK WITH METHOD OF OBJECT XI2DPU: ', xi2dpu) 
    #   # 
    #   try:
    #                        
    #       callback2dpu = xi2dpu.set2samplercallback()                                  
    #       print('(Step 124B/700) OF DPU2SAMPLER4XI5TEST - SET SAMPLER WITH CALLBACK TO: ', callback2dpu)
    #       # <function trace2sampler4dpu at 0x00000000039676C8> 
    #                         
    #   except:
    #       print('(Step 124Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK WITH METHOD ***', time4xi()) 
    #
    #">
    # ---------------------------------------------------------------------------------------------   
    def set2samplercallback(self, task4set2samplercallback = None): 
        '''
        set2samplercallback of DPU2Sampler4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "DPU2Sampler4Xi"
        method2print = "set2samplercallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2samplercallback-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2samplercallback-passed-to-set2samplercallback-of-DPU2Sampler4Xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2samplercallback-passing-to-set2samplercallback-by-set2samplercallback-of-DPU2Sampler4Xi: " + str(task4set2samplercallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # None 
        
        
        callback2dpu4sampler = {} 
        try:
            callback2dpu4sampler = set2samplercallback4dpu (task4set2samplercallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2dpu4sampler-failed-by-set2samplercallback-of-DPU2Sampler4Xi: " + str(callback2dpu4sampler) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2dpu4sampler-returning-by-set2samplercallback-of-DPU2Sampler4Xi: " + str(callback2dpu4sampler) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2sampler4dpu at 0x00000000038CF5C8> 
        
                                             
        return callback2dpu4sampler
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-DPU2Sampler4Xi" usage = "
    #
    #   try:
    #       print(xi2dpu.sense())
    #   
    #       print('=' *33)          
    #       print('(Step 170B/700) OF DPU2SAMPLER4XI5TEST - SENSED ', time4xi()) 
    #       # {'classvariable2dpu-of-DPU2Sampler4Xi': 4, 'object': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B02F98>}
    #       
    #       print('=' *33)
    #   except:
    #       print('(Step 170Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses DPU2Sampler4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'DPU2Sampler4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; DPU2Sampler4Xi-sensing-by-sense-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'dpu2sampler4xi.DPU2Sampler4Xi'>
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-DPU2Sampler4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B5FBE0>}
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2dpu-of-DPU2Sampler4Xi'] = DPU2Sampler4Xi.classvariable2dpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-DPU2Sampler4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; DPU2Sampler4Xi-sensed-by-sense-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # <class 'dpu2sampler4xi.DPU2Sampler4Xi'>
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-DPU2Sampler4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'classvariable2dpu-of-DPU2Sampler4Xi': 4, 'object': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B5FBE0>} 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-DPU2Sampler4Xi" usage = "
    # 
    #   try:
    #       print(xi2dpu.reason())
    #   
    #       print('=' *33)          
    #       print('(Step 171B/700) OF DPU2SAMPLER4XI5TEST - REASONED ', time4xi())
    #       # {'object-reason-object4xi': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B02F98>, 'time-reason-of-DPU2Sampler4Xi': '04:32:25 11/07/11 Pacific Standard Time'}
    #       
    #       print('=' *33)       
    #   except:
    #       print('(Step 171Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO REASON ', time4xi())   
    #
    #">
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons DPU2Sampler4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'DPU2Sampler4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; DPU2Sampler4Xi-reasoning-by-reason-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <class 'dpu2sampler4xi.DPU2Sampler4Xi'>
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-DPU2Sampler4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object-reason-object4xi': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B5FBE0>}
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-DPU2Sampler4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-DPU2Sampler4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; DPU2Sampler4Xi-reasoned-by-reason-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # <class 'dpu2sampler4xi.DPU2Sampler4Xi'>
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-DPU2Sampler4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'object-reason-object4xi': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B5FBE0>, 'time-reason-of-DPU2Sampler4Xi': '22:37:25 11/07/11 Pacific Standard Time'}              
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-DPU2Sampler4Xi" usage = "
    #
    #   try:
    #       print(xi2dpu.ace())
    #   
    #       print('=' *33)          
    #       print('(Step 172B/700) OF DPU2SAMPLER4XI5TEST - ACED ', time4xi())                                                 
    #       # {'cores-of-DPU2Sampler4Xi': 4, 'object8xi': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B02F98>} 
    #       
    #       print('=' *33) 
    #   except:
    #       print('(Step 172Z/700) OF DPU2SAMPLER4XI5TEST *** FAILED TO ACE ', time4xi())                                       
    #    
    #">
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces DPU2Sampler4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'DPU2Sampler4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-DPU2Sampler4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 22:37:25 11/07/11 Pacific Standard Time 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; DPU2Sampler4Xi-acing-by-ace-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'dpu2sampler4xi.DPU2Sampler4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-DPU2Sampler4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object8xi': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B5FBE0>}


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-DPU2Sampler4Xi'] = DPU2Sampler4Xi.classvariable2dpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-DPU2Sampler4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; DPU2Sampler4Xi-aced-by-ace-of-DPU2Sampler4Xi: " + str(DPU2Sampler4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'dpu2sampler4xi.DPU2Sampler4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-DPU2Sampler4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # {'cores-of-DPU2Sampler4Xi': 4, 'object8xi': <dpu2sampler4xi.DPU2Sampler4Xi object at 0x0000000003B5FBE0>}
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   dpu2sampler4xi5test.txt
#   sense-dpu2sampler4xi5test.xml
#   reason-dpu2sampler4xi5test.xml
#   ace-dpu2sampler4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dpu2sampler4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
